{ }:
let
  pkgs = import <nixpkgs> { overlays = [ (import ./overlay.nix) ]; };
  hx = import ./default.nix { inherit pkgs; };
in
  pkgs.mkShell {
    buildInputs = [
    	hx.binutils-riscv32 hx.binutils-riscv64 hx.gcc-riscv32 hx.gcc-riscv64 pkgs.rustc pkgs.cargo hx.rust-riscv32i-crates
    	(pkgs.python3.withPackages(ps: [hx.nmigen hx.nmigen-boards hx.heavycomps hx.minerva]))
    	pkgs.yosys
      pkgs.nextpnr
      pkgs.trellis
      pkgs.openocd
    ];
    RUSTFLAGS="-L ${hx.rust-riscv32i-crates}/lib/rustlib/riscv32i-unknown-none-elf/lib -C linker=riscv32-unknown-elf-ld -C link-arg=-Tlink.x";
  }
